/* event.c */

#include <string.h>
#include "waved.h"
#include "video.h"
#include "fk.h"

#define TBSZ        13

void    window_max();
void    zoom_in();
void    zoom_out();
void    pan_left();
void    pan_right();
void    pan_left_sm();
void    pan_right_sm();
void    window_edit();

static int mouse_present = 0;
static int mouse_sh = 1;
static int mouse_on = 0;
static int mlb, mrb, mcx, mcy, mlx, mly;
static int eventq = 1;
static int mouse_evnt = 0;
static int last_event = 0;

void
set_mouse_event(int m)
{
    mouse_evnt = m;
}

void
queue_event()
{
    static int lls = 0, lrs = 0;
    static int mlx = 0, mly = 0;

    if (_kbhit()) {
	eventq = _getch();
	if (eventq == 0)
	    eventq = FN | _getch();
    } else if (mouse_evnt) {
	llb = mlb;
	lrb = mrb;
	gr_mstatus(&mlb, &mrb, &mcx, &mcy);
	if ((mcx != mlx || mcy != mly) && (mouse_evnt > 1)) {
	    mlx = mcx;
	    mly = mcy;
	    eventq = MMV;
	} else if (mlb && !llb) {
	    eventq = MDL;
	} else if (mrb && !lrb) {
	    eventq = MDR;
	}
    }
}

int
chkevent()
{
    if (eventq == 0)
	queue_event();
    return (eventq);
}

int
lastevent()
{
    return (last_event);
}

int
getevent()
{
    int     c;

    mouse_shows(1);
    while (eventq == 0)
	queue_event();
    c = last_event = eventq;
    eventq = 0;
    mouse_shows(0);
    return (c);
}

void
get_mouse_location(int *x, int *y)
{
    *x = mcx;
    *y = mcy;
}
