/* gettxt.c */

#include <string.h>
#include "waved.h"
#include "video.h"
#include "fk.h"

#define Esc     27

int getevent();
void g_gettp(int *, int *);
void g_text(int, int, char *);

int
g_getstr(char *s, int len)
{
    int     i, j, k, c, m, n, x, y;

    if (len <= 0 || s == NULL)
	return (0);
    g_gettp(&x, &y);
    m = len - 1;    /* maximum number of characters in string */
    n = strlen(s);  /* number of characters in string */
    i = n;          /* index of cursor within string */
    k = 0;          /* number of characters printed */
    for (;;) {
	g_erase(x, y, k);
        g_text(x, y, s);
	k = strlen(s);
	if (i < m)
	        g_txt_cur(x + i * ch_wd, y);
	c = getevent();
	g_erase(x + i * ch_wd, y, 1);
	switch (c) {
	case 1:		/* CNTL-A */
	case FK_Home:	/* HOME */
	    i = 0;
	    break;
	case 2:		/* CNTL-B */
	case FK_Left_Arrow:	/* arrow left */
	    if (i > 0)
		i--;
	    break;
	case 6:		/* CNTL-F */
	case FK_Right_Arrow:	/* arrow right */
	    if (i < n)
		i++;
	    break;
	case 11:	/* CNTL-K */
	    n = i;
	    s[n] = '\0';
	    break;
	case 21:	/* CNTL-U */
	    n -= i;
	    for (j = 0; j < n; j++)
		s[j] = s[j + i];
	    i = 0;
	    s[n] = '\0';
	    break;
	case 5:		/* CNTL-E */
	case FK_End:	/* END */
	    i = n;
	    break;
	case FK_Del:	/* DEL */
	case 127:	/* DEL */
	case 4:		/* CNTL-D */
	case 8:		/* CNTL-H */
	    if (c == FK_Del)
		c = 4;
	    if (c == 4) {
	        if (i < n)
                    i++;
                else
                    break;
	    }
            if (i > 0 && i <= n) {
                if (c == 4 || c == 8 || c == 127) {
                    for (j = i; j < n && j > 0; j++)
                        s[j - 1] = s[j];
                    n--;
                    s[n] = '\0';
                }
                i--;
            }
	    break;
	case '\r':
	case '\n':
	case MDR:
	    s[n] = 0;
	    return ('\r');
	case MDL:
	    s[n] = 0;
	    return (MDL);
	case Esc:
	    s[0] = 0;
	    return (Esc);
	default:
	    if (c < ' ' || c > '~') {
	        return (c);
            }
	    if (n < m) {
		for (j = n; j > i; j--)
		    s[j] = s[j - 1];
		s[i] = c;
		n++;
		s[n] = '\0';
	    }
	    if (i < n) {
		i++;
	    }
	}
    }
}

void
g_gettxt(str, nc)
char   *str;
{
    *str = '\0';
    if (g_getstr(str, nc) == MDL)
        *str = '\0';
}

int
getyes()
{
    int     c;

    c = getevent();
    if (c == 'y' || c == 'Y' || c == MDR)
	return (1);
    return (0);
}
