/* iod.c */

#include <stdio.h>
#include <dos.h>
#include "iod.h"

int     adbits = 8;
int     adzero = 128;
int     lptflg = 0;
int     iod_num = -1;
int     iod_port = 0;
int     adgain = 2;
int     adchan = 0;
int     adfeed = 0;
int     dachan = 0;
long    adnpts = 0;
long    adrate = 0;
static int idummy();
static void vdummy();

int     (*input_adc)() = idummy;
int     (*output_dac)() = idummy;
void    (*stop_iod)() = vdummy;

static int idummy(){return(0);}
static void vdummy(){}

void
never_called()              /* for lint */
{
    (void) input_adc(NULL, 0L, 0L);
    (void) output_dac(NULL, 0L, 0L);
    stop_iod();
    adnpts = adnpts;
    adbits = adbits;
    adrate = adrate;
}

void
set_timer_rate(int count)
{
    _disable();
    (void) _outp(0x43, (3 << 1) | (3 << 4));
    (void) _outp(0x40, count % 256);
    (void) _outp(0x40, count / 256);
    (void) _outp(0x43, (3 << 1) | (3 << 4));
    (void) _outp(0x40, count % 256);
    (void) _outp(0x40, count / 256);
    _enable();
}

void
set_dev_port(int d, char c)
{
    int     n;
    static short int FAR *lpt_port[4] = {
	(short int FAR *) 0x408, (short int FAR *) 0x40A,
	(short int FAR *) 0x40C, (short int FAR *) 0x40E
    };
    static short int FAR vmk_port[4] = {0x22F, 0x24F, 0x28F, 0x2CF};

    n = (c >= '1' && c <= '4') ? c - '1' : 0;
    lptflg = d;
    iod_port = d ? *lpt_port[n] : vmk_port[n];
    iod_num = 1;
}

void
set_hex_port(char *s)
{
    int     n;

    sscanf(s, "%x", &n);
    lptflg = 0;
    iod_port = n;
    iod_num = 1;
}

void
msdelay(long msec)
{
#ifdef _MSC_VER
    volatile char FAR *pf;
    volatile char flag = 0;
    long usec;
    union _REGS rg;
    struct _SREGS sr;
   
    usec = msec * 1000;
    pf = &flag;
    rg.x.ax = 0x8300;	/* event wait - set interval */
    rg.x.cx = (usec >> 16) & 0xFFFF;
    rg.x.dx = usec & 0xFFFF;
    sr.es = _FP_SEG(pf);
    rg.x.bx = _FP_OFF(pf);
    (void) _int86x(0x15, &rg, &rg, &sr);
    while (flag == 0)
        continue;
#else /*_MSC_VER */
    delay(msec);
#endif /*_MSC_VER */
}
