/* iod0 - I/O Device = PC internal speaker */

#include <dos.h>
#include "iod.h"

#define DACZ	128
#define PORT_B  0x61

void stop_iod0();
int output_dac0(SIGPTR, long, long);
int input_adc0(SIGPTR, long, long);

static SIGPTR isr_samp;
static long isr_count = 0;
static long isr_npts = 0;
static int isr_ticks = 0;
static int spk_0;
static int spk_1;
static int first_io = 1;

int
init_iod0()
{
    adbits = 8;
    adzero = DACZ;
    isr_npts = 0;
    isr_count = 0;
    stop_iod = stop_iod0;
    output_dac = output_dac0;
    input_adc = input_adc0;
    return (0);
}

void
stop_iod0()
{
    if (isr_npts != 0) {
	isr_npts = 0;
    }
}

int
output_dac0(buf, npts, rate)
SIGPTR  buf;
long    npts, rate;
{
    int v, m, n, nn, mn;
    int spksv, spk;
        
    if (npts <= 0)
	return (0);
    if (rate <= 20)
	return (1);
    isr_samp = buf;
    isr_count = npts;
    isr_npts = npts;
    spksv = _inp(PORT_B);
    spk_0 = spksv & 0xFC;
    spk_1 = spk_0 | 2;
    while (isr_count-- > 0) {
	v = *isr_samp++;
        n = 128;
        m = (int)(((long) v * n) / 256);
        nn = m - n / 2;
        mn = m - n;
        while (n-- > 0) {
            if (nn > 0) {
            	spk = spk_1;
                nn += mn;
            } else {
            	spk = spk_0;
                nn += m;
            }
            (void) _outp(PORT_B, spk);
	}
    }
    (void) _outp(PORT_B, spksv);
    isr_npts = 0;
    return (0);
}

int
input_adc0(buf, npts, rate)
SIGPTR  buf;
long    npts, rate;
{
    adnpts = 0;
    adrate = 0;
    return (1);
}
