/* mark.c */

#include <stdio.h>
#include <string.h>
#include "waved.h"
#include "video.h"
#include "fk.h"

int     getevent();
int     mouse_aw();
void    blankmarks();
void    ins_mark();
void    ins_new_mark();
void    del_mark();
void    goto_mark();
void    ins_mark_sm();
void    ins_new_mark_sm();
void    del_mark_sm();
void    goto_mark_sm();
void    goto_samp();
void    get_mouse_location();

void
markquery()
{
    int     c;
    static char *mis[] =
    {"New", "Insert", "Delete", "Go_to", "Blank", ""};

    c = menu("MARK", mis);

    switch (c) {
    case 'N':
	ins_new_mark();
	break;
    case 'I':
	ins_mark();
	break;
    case 'D':
	del_mark();
	break;
    case 'G':
	goto_mark();
	break;
    case 'B':
	blankmarks(aw);
	showdata();
	break;
    }
}

/* ins_mark - gets character for new mark and updates screen */

void
ins_mark()
{
    int     c;

    if (scrollmode) {
	ins_mark_sm();
	return;
    }
    if (sig[aw].siglen <= 0)
	return;
    putmsg(" INSERT MARK:  Enter letter for mark  ");
    c = getmark(0);
    if (c < 26)
	update_mark(c, curspnt);
    clrmsg();
}

void
ins_new_mark()
{
    int     c;

    if (scrollmode) {
	ins_new_mark_sm();
	return;
    }
    if (sig[aw].siglen <= 0)
	return;
    c = newmark();
    if (c < 26)
	update_mark(c, curspnt);
}

/* del_mark - gets character for old mark and erases it from screen */

void
del_mark()
{
    int     c;

    if (scrollmode) {
	del_mark_sm();
	return;
    }
    if (sig[aw].siglen <= 0)
	return;
    putmsg(" DELETE MARK:  Enter letter for mark  ");
    c = getmark(0);
    if (c < 26)
	update_mark(c, NOMARK);
    clrmsg();
}

void
goto_mark()
{
    int     c;

    if (scrollmode) {
	goto_mark_sm();
	return;
    }
    putmsg(" GOTO MARK: enter letter for mark");
    c = getmark(0);
    if (c < NMARK)
	goto_samp(sig[aw].sigmrk[c]);
    clrmsg();
}

/* BLANKMARKS to get rid of all "letter" marks */

void
blankmarks(int num)
{
    int     j;
    SIGNAL *s;


    s = &sig[num];
    for (j = 0; j < 26; j++)
	s->sigmrk[j] = NOMARK;
    s->sigmrk[HOME_MARK] = 0;
    s->sigmrk[END_MARK] = s->siglen;
}

int
newmark()
{
    int     j;

    for (j = 0; j < 26; j++)
	if (sig[aw].sigmrk[j] == NOMARK)
	    return (j);
    return (NOMARK);
}

int
getmark(int n)
{
    int     c, x, y, m = 0, s;

    c = getevent();
    if (c == MDL) {
        get_mouse_location(&x, &y);
        if (inwind(x, y, aw)){
            m = SELECT_MARK + n;
            s = mouse_aw();
            switch(s) {
            case 1:
                sig[aw].sigmrk[SELECT_MARK] = curspnt;
                sig[aw].sigmrk[SELECT1_MARK] = 0;
                sig[aw].sigmrk[SELECT2_MARK] = sig[aw].siglen;
                break;
            case 2:
            case 3:
                sig[aw].sigmrk[m] = win[aw].winmrk1;
                break;
            case 4:
            case 5:
                sig[aw].sigmrk[m] = win[aw].winmrk2;
                break;
            default:
                sig[aw].sigmrk[m] = curspnt;
            }
        }
    } else if (c >= 'A' && c <= 'Z') {
	m = c - 'A';
    } else if (c >= 'a' && c <= 'z') {
	m = c - 'a';
    } else if (c == '.') {
	sig[aw].sigmrk[CURSOR_MARK] = curspnt;
	m = CURSOR_MARK;
    } else if (c == FK_Home) {
        m = HOME_MARK;
    } else if (c == FK_End) {
        m = END_MARK;
    } else if (c == '*') {
        m = SELECT_MARK + n;
        sig[aw].sigmrk[SELECT1_MARK] = 0;
        sig[aw].sigmrk[SELECT2_MARK] = sig[aw].siglen;
    } else if (c == 1) {
        m = SELECT1_MARK;
    } else if (c == 2) {
        m = SELECT2_MARK;
    } else {
        m = NOMARK;
    }
    return (m);
}

char   *
marktext(c)
{
    char *s;
    static char ltrnam[2];
    static char *markname[6] = {
        "[Home]", "[End]", "[cursor]", "[select]", "[select1]", "[select2]"
    };

    if (c < 0 || c > NMARK) {
        s = "????";
    } else if (c >= 26) {
        s = markname[c - 26];
    } else {
        ltrnam[0] = c + 'A';
        ltrnam[1] = '\0';
        s = ltrnam;
    }
    return (s);
}

/* getwinmrk - get window number and two marks */

int
getwinmrk(char *str, int flg)
{
    char   *disp, *mrktxt1, *mrktxt2;
    char   *mtc1 = "  From mark ";
    char   *mtc2 = "  To mark ";
    char   *mti1 = "  From [new] mark ";
    char   *mti2 = "  To [old] mark ";
    int     mx, valid = 0;
    SIGNAL *s;

    s = &sig[aw];
    if (s == NULL)
	return (0);
    clrmsg();
    mx = msgx + strlen(str) * ch_wd;
    g_settextclr(msfgc, msbgc);
    g_text(msgx, msgy, str);
    win_num = clpwin;
    if (flg == 2) {
	mrktxt1 = mti1;
	mrktxt2 = mti2;
    } else {
	mrktxt1 = mtc1;
	mrktxt2 = mtc2;
    }
    if (win_num >= 0 && win_num < NWIND) {
        s->sigmrk[SELECT1_MARK] = NOMARK;
        s->sigmrk[SELECT2_MARK] = NOMARK;
	g_text(mx, msgy, mrktxt1);
	mx += strlen(mrktxt1) * ch_wd;
	seg_mark1 = getmark(1);
	if (seg_mark1 >= 0 && seg_mark1 < NMARK) {
	    disp = marktext(seg_mark1);
            g_settextclr(msfgc, msbgc);
	    g_text(mx, msgy, disp);
            if (seg_mark1 == SELECT1_MARK && s->sigmrk[SELECT2_MARK] != NOMARK) {
                seg_mark1 = HOME_MARK;
                seg_mark2 = END_MARK;
            } else {
                mx += strlen(disp) * ch_wd;
                g_text(mx, msgy, mrktxt2);
                mx += strlen(mrktxt2) * ch_wd;
                seg_mark2 = getmark(2);
            }
	    if (seg_mark2 >= 0 && seg_mark2 < NMARK) {
		disp = marktext(seg_mark2);
                g_settextclr(msfgc, msbgc);
		g_text(mx, msgy, disp);
		mx += strlen(disp) * ch_wd;
		if (s->sigmrk[seg_mark1] != NOMARK
		    && s->sigmrk[seg_mark2] != NOMARK)
		    valid = 1;
		if (s->sigmrk[seg_mark2] != NOMARK && flg == 2)
		    valid = 1;
	    }
	}
    }
    return (valid);
}
