/* memory.h - handles memory allocation differences between TC and MSC */

#ifdef TURBOC
#include <alloc.h>
#define MALLOC(n,s) farmalloc((n)*(s))
#define FREE(p)     farfree((void far *) p)
#else /* TURBOC */
#ifdef HUGE_PTR
#include <malloc.h>
#define MALLOC(n,s) _halloc((long)(n),(s))
#define FREE(p)     _hfree((void __huge *)p)
#else /* HUGE_PTR */
#include <malloc.h>
#define MALLOC(n,s) malloc((n) * (s))
#define FREE(p)     free((void *) p)
#endif /* HUGE_PTR */
#endif /* TURBOC */

