/* setup.c */

#include <stdio.h>
#include <stdlib.h>
#include "waved.h"
#include "video.h"

#define ESC 27

int     menu();
void    devicequery();

/* setup - to adjust topsamp, the maximum samples in an input session */

void
setup()
{
    char    str[80];
    int     c;
    long    lv;
    double  dv, r, rt;
    extern int fmwnt, fmhfe;
    extern int lpnco, lpwnt, lphfe;
    static char *mis1[] = {"Device", "Rate", "Time", "Moment", "LPC", ""};
    static char *mis2[] = {"ADC", "DAC", "deFault", ""};
    static char *fm1[] = {"Rectangular", "Hamming", "Blackman", ""};
    static char *fm2[] = {"Yes", "No", ""};

    c = menu("SET", mis1);
    switch (c) {
    case 'D':
	devicequery();
	break;
    case 'R':
	r = sig[aw].adrate;
        rt = (r <= 0) ? topsamp / def_rate : topsamp / r;
        c = menu("SET RATE", mis2);
        switch (c) {
        case 'A':
            sprintf(str, "SET: ADC sample rate = (%ld/s)  ", sig[aw].adrate);
            get_response(str, str, 80);
            if ((lv = atol(str)) <= 0)
                break;
            sig[aw].adrate = lv;
            break;
        case 'D':
            sprintf(str, "SET: DAC sample rate = (%ld/s)  ", sig[aw].darate);
            get_response(str, str, 80);
            if ((lv = atol(str)) <= 0)
                break;
            sig[aw].darate = lv;
            break;
        case 'F':
            sprintf(str, "SET: default sample rate = (%ld/s)  ", def_rate);
            get_response(str, str, 80);
            if ((lv = atol(str)) <= 0)
                break;
            def_rate = lv;
            sig[aw].adrate = def_rate;
            sig[aw].darate = def_rate;
            break;
        }
        if (sig[aw].adrate != r) {
            topsamp = (long) (rt * sig[aw].adrate);
            if (topsamp > MAX_SAM)
                topsamp = MAX_SAM;
        }
        break;
    case 'T':
	r = sig[aw].adrate;
        rt = (r <= 0) ? topsamp / def_rate : topsamp / r;
	sprintf(str, "SET RECORD TIME = (%.3f s)  ", rt);
	get_response(str, str, 80);
	if ((dv = atof(str)) <= 0)
	    return;
        if (dv != rt) {
            topsamp = (long) (dv * r);
            if (topsamp > MAX_SAM)
                topsamp = MAX_SAM;
        }
	break;
    case 'M':
        c = menu("FREQUENCY MOMENT WINDOW TYPE", fm1);
        if (c == 'R')
            fmwnt = 0;
        else if (c == 'H')
            fmwnt = 1;
        else if (c == 'B')
            fmwnt = 2;
        c = menu("HIGH-FREQUENCY EMPHASIS", fm2);
        if (c == 'Y')
            fmhfe = 1;
        else if (c == 'N')
            fmhfe = 0;
        sprintf(str, 
            " Frequency moments have %s window & %s high-freq. emphasis.",
            fm1[fmwnt], fmhfe ? "6 dB/oct" : "no");
        putmsgwk(str);
        break;
    case 'L':
        if (lpnco <= 0)
            lpnco = 2 + sig[aw].adrate / 1000;
        sprintf(str, "LINEAR PREDICTION:  Number of coefficients? (1-%d) [%d] ",
    		MAXLPC, lpnco);
	get_response(str, str, 80);
	if (*str == ESC)
	    return;
	if ((c = atoi(str)) > 0)
            lpnco = c;
        c = menu("WINDOW TYPE", fm1);
        if (c == 'R')
            lpwnt = 0;
        else if (c == 'H')
            lpwnt = 1;
        else if (c == 'B')
            lpwnt = 2;
        c = menu("HIGH-FREQUENCY EMPHASIS", fm2);
        if (c == 'Y')
            lphfe = 1;
        else if (c == 'N')
            lphfe = 0;
        sprintf(str, 
            " Lin. pred. has %d coef., %s window, & %s h.f.emph.",
            lpnco, fm1[lpwnt], lphfe ? "6 dB/oct" : "no");
        putmsgwk(str);
        break;
    }
}

