/* video.h */

#define UNKNOWN		0	/* Unknown board type */
#define MONO		1	/* IBM Monochrome card */
#define CGA		2	/* IBM Color graphics adapter (CGA) */
#define HERCULES	3	/* Hercules monochrome graphics card */
#define EGA_MONO	4	/* IBM Enhanced graphics adapter (EGA)
				   w/monochrome display */
#define EGA_COLOR	5	/* EGA w/color display */
#define EGA_HIGH	6	/* EGA w/high resolution color display */
#define VGA_MONO	7	/* IBM Enhanced graphics adapter (EGA)
				   w/monochrome display */
#define VGA_COLOR	8	/* EGA w/color display */
#define PEGA		9	/* Paradise Autoswitch EGA, 640x480 */

#define CHRWID		8
#define MNBS		8	/* minimum bit shift for scroll mode */

extern int grfcrd;		/* indicates type of graphic card 0 = EGA 1 =
				   HGC 2 = CGA 3 = VGA -1 = UNKNOWN */

extern int scrszx, scrszy;	/* screen size x and y */
extern int boxx1, boxy1;	/* box lower-left corner */
extern int boxx2, boxy2;	/* box upper-right corner */
extern int cw1x1, cw1y1;	/* closeup window 1 lower-left  corner */
extern int cw1x2, cw1y2;	/* closeup window 1 upper-right corner */
extern int cw2x1, cw2y1;	/* closeup window 2 lower-left  corner */
extern int cw2x2, cw2y2;	/* closeup window 2 upper-right corner */
extern int hlpx1, hlpy1;	/* help screen lower-left  corner */
extern int hlpx2, hlpy2;	/* help screen upper-right corner */
extern int lvlx1, lvly1;	/* level window lower-left  corner */
extern int lvlx2, lvly2;	/* level window upper-right corner */
extern int wavcol;      	/* wave text color */
extern int tlbcol, stscol;	/* toolbar and status text color */
extern int boxcol, active;	/* nonactive and active box colors */
extern int csrcol, scwcol;	/* cursor and scroll window colors */
extern int mkfgc, scbgc;	/* marker foregound/screen background colors */
extern int hsfgc, hsbgc;	/* help screen foreground/background colors */
extern int msfgc, msbgc;	/* help screen foreground/background colors */
extern int wnfgc, wnbgc;	/* window number foreground/background colors */
extern int blfgc, blbgc;	/* box label foreground/background colors */
extern int bmfgc, bmbgc;	/* box message foreground/background colors */
extern int clfgc, clbgc;	/* closeup label foreground/background colors */
extern int msgx, msgy;		/* message starting position */
extern int stsx, stsy;		/* sts starting position */
extern int bxlx, bxly;		/* box label starting position */
extern int bxmx, bxmy;		/* box message starting position */
extern int cw1x, cw1y;		/* closeup window 1 label starting position */
extern int cw2x, cw2y;		/* closeup window 2 label starting position */
extern int cumx, cumy;		/* cursor message starting position */
extern int ch_wd, ch_ht, ln_sp;	/* character width, height, and line spacing */

int     g_videotype();
int     g_savscr();
int     g_getstr();
void	gr_xshft(int, int, int);
