/* view.c */

#include <stdlib.h>
#include <string.h>
#include "waved.h"
#include "video.h"

int     menu();
void    chaw();
void    viewall();
void    viewclp();
void    viewseg();
void    windquery();
void    window_new();
void    window_close();
void    window_scroll();
void    window_max();
void    window_up();
void    window_dup();
void    pan();
void    pan_left();
void    pan_right();
void    zoom();
void    zoom_in();
void    zoom_out();
void    showall();
void    showwave();
void    showwindow();
void    windswap();
void    sigdel();
void    g_cursor_del();
void    g_sb_del();
void    goto_samp();

void
viewquery()
{
    int     c;
    static char *mis[] = {
	"All", "Clip", "Segment", "Pan", "Zoom", ""
    };

    c = menu("VIEW", mis);
    switch (c) {
    case 'A':
	viewall();
	break;
    case 'C':
	viewclp();
	break;
    case 'S':
	viewseg();
	break;
    case 'P':
	pan();
	break;
    case 'Z':
	zoom();
	break;
    }
}

void
viewall()
{
    win[aw].winmrk1 = sig[aw].sigmrk[HOME_MARK];
    win[aw].winmrk2 = sig[aw].sigmrk[END_MARK];
    showwindow(aw);
}

void
viewclp()
{
    fsw = (fsw == 0) ? 1 : 0;
    if (aw < fsw)
	chaw(fsw);
    showall();
}

void
viewseg()
{
    if (getwinmrk(" VIEW SEGMENT:", 0)) {
	ordmrk();
	win[aw].winmrk1 = sig[aw].sigmrk[seg_mark1];
	win[aw].winmrk2 = sig[aw].sigmrk[seg_mark2];
	showwindow(aw);
    }
}

void
zoom()
{
    int     c;
    static char *mis[] = {"In", "Out", ""};

    c = menu("ZOOM", mis);
    switch (c) {
    case 'I':
	zoom_in();
	break;
    case 'O':
	zoom_out();
	break;
    }
}

void
zoom_in()
{
    long    ipnt, npts, nsmp, np, ip, hp;

    nsmp = sig[aw].siglen;
    ipnt = win[aw].winmrk1;
    npts = win[aw].winmrk2 - ipnt;
    if (npts > 2) {
	np = 2 + npts / 2;
	hp = np / 2;
	ip = limit(0, curspnt - hp, nsmp - np);
	if (ip != ipnt || np != npts) {
	    win[aw].winmrk1 = limit(0, ip, nsmp);
	    win[aw].winmrk2 = limit(0, ip + np, nsmp);
	    showwindow(aw);
	}
    }
}

void
zoom_out()
{
    long    ipnt, npts, nsmp, ip, np, hp;

    nsmp = sig[aw].siglen;
    ipnt = win[aw].winmrk1;
    npts = win[aw].winmrk2 - ipnt;
    if (npts < nsmp) {
	np = npts * 2;
	hp = np / 2;
	ip = limit(0, curspnt - hp, nsmp - np);
	if (ip != ipnt || np != npts) {
	    win[aw].winmrk1 = limit(0, ip, nsmp);
	    win[aw].winmrk2 = limit(0, ip + np, nsmp);
	    showwindow(aw);
	}
    }
}

void
pan()
{
    int     c;
    static char *mis[] = {"Left", "Right", ""};

    c = menu("PAN", mis);
    switch (c) {
    case 'L':
	pan_left();
	break;
    case 'R':
	pan_right();
	break;
    }
}

void
pan_left()
{
    long    ipnt, npts, nsmp, ip;

    nsmp = sig[aw].siglen;
    ipnt = win[aw].winmrk1;
    npts = win[aw].winmrk2 - ipnt;
    ip = limit(0, (ipnt - npts / 2), nsmp - npts);
    if (ip != ipnt) {
	win[aw].winmrk1 = ip;
	win[aw].winmrk2 = ip + npts;
	curspnt = ip + npts / 2;
	showwindow(aw);
    }
}

void
pan_right()
{
    long    ipnt, npts, nsmp, ip;

    nsmp = sig[aw].siglen;
    ipnt = win[aw].winmrk1;
    npts = win[aw].winmrk2 - ipnt;
    ip = limit(0, (ipnt + npts / 2), nsmp - npts);
    if (ip != ipnt) {
	win[aw].winmrk1 = ip;
	win[aw].winmrk2 = ip + npts;
	curspnt = ip + npts / 2;
	showwindow(aw);
    }
}

void
windquery()
{
    int     c;
    static char *mis[] = {
	"New", "Close", "Scroll", "Maximize", "Duplicate", "Up", ""
    };

    c = menu("WINDOW", mis);
    switch (c) {
    case 'C':
	window_close();
	break;
    case 'N':
	window_new();
	break;
    case 'S':
	window_scroll();
	break;
    case 'M':
	window_max();
	break;
    case 'D':
	window_dup();
	break;
    case 'U':
	window_up();
	break;
    }
}

void
window_new()
{
    if (lsw < MAXNSW) {
	lsw++;
	windinit(lsw);
	showall();
	chaw(lsw);
    }
}

void
window_close()
{
    int     i;

    if (lsw > 1 && aw != clpwin) {
	for (i = aw; i < lsw; i++)
	    windswap(i, i + 1);
	sigdel(lsw);
	lsw--;
	if (aw > lsw)
	    chaw(lsw);
	showall();
    }
}

void
window_up()
{
    if (aw > 1) {
	windswap(aw, aw - 1);
	chaw(aw - 1);
	showall();
    }
}

void
window_scroll()
{
    if (sig[aw].siglen > 0) {
	g_sb_del();
	g_cursor_del();
	showwave(aw);
	if (thru)
	    return;
	showwindow(aw);
    }
    goto_samp(curspnt);
}

void
window_max()
{
    maximize = !maximize;
    showall();
}

void
window_dup()
{
    if (lsw < MAXNSW) {
	lsw++;
	windinit(lsw);
	saveseg(lsw, HOME_MARK, END_MARK);
	showall();
	chaw(lsw);
    }
}

void
windswap(w1, w2)
{
    WINDOW  twin[1];
    SIGNAL  tsig[1];

    memcpy(&twin[0], &win[w2], sizeof(WINDOW));
    memcpy(&tsig[0], &sig[w2], sizeof(SIGNAL));
    memcpy(&win[w2], &win[w1], sizeof(WINDOW));
    memcpy(&sig[w2], &sig[w1], sizeof(SIGNAL));
    memcpy(&win[w1], &twin[0], sizeof(WINDOW));
    memcpy(&sig[w1], &tsig[0], sizeof(SIGNAL));
}
