/* waved.h */ 

#define BUFSIZE         512
#define DAC_SELECT      0
#define SOURCE          0
#define MAX_CHAN        8
#ifdef    MSC
#define MAX_SAM         (128*1024L)
#else  /* MSC */
#define MAX_SAM         (1024*1024L)
#endif /* MSC */
#define MAX_WIN         (MAX_SAM / 2)
#define MAXLPC          50
#define HDR_SIZ         256
#define NWIND           6
#define MAXNSW          (NWIND - 1)
#define NOGRAF          -1
#define NOMARK          -1L
#define HOME_MARK       26
#define END_MARK        27
#define CURSOR_MARK     28
#define SELECT_MARK     29
#define SELECT1_MARK    30
#define SELECT2_MARK    31
#define NMARK           32
#define FNMSZ           40	/* DOS 8.3 file spec */
#ifdef MSC
#define FNSZ            12	/* DOS 8.3 file spec */
#define PATHSZ          64
#else
#define FNSZ            80
#define PATHSZ          256
#endif
#define MAXARG		40
#define limit(mn,aa,mx) (((aa)<(mn))?(mn):((aa)>(mx))?(mx):(aa))

extern double ftdbsc, ftdbof;
extern int aw;
extern int thru;
extern int fsw;
extern int lsw;
extern int nsw;
extern int clpwin;
extern int win_num, seg_mark1, seg_mark2;
extern int scroff;
extern int scrollbox, maximize, scrollmode, siginfmsg;
extern long topsamp;
extern long curspnt, cursmin, cursmax;
extern long def_rate;
extern short cpu_lsb;
extern short buffer[BUFSIZE];

#ifndef SIGPTRDEF
#ifdef HUGE_PTR
typedef short huge *SIGPTR;
#else
typedef short *SIGPTR;
#endif /* HUGE_PTR */
#define SIGPTRDEF
#endif  /* SIGPTRDEF */

typedef struct {
    short   winx1, winy1, winx2, winy2;
    short   wtibc, wbkgc;
    short   winmod;
    long    winmrk1, winmrk2;
    long    wincp;
}       WINDOW;

extern WINDOW win[NWIND];

typedef struct {
    char    sigfnm[FNMSZ];
    short   sigtom;
    short   sigmin;
    short   sigmax;
    SIGPTR  sigbuf;
    short   sigzer;
    short   sgbits;
    long    siglen;
    long    sgtime;
    long    adrate, darate;
    long    sigmrk[NMARK];
    char    sigfty, sigdty, sigbsw, sigatr;
    char    sigfmt, sgnchn, resrv1, resrv2;
}       SIGNAL;

extern SIGNAL sig[NWIND];

/* function prototypes */

int autoc(int, float *, int, float *, float *, float *, float *);
int chkevent();
int getevent();
int getmark(int);
int getwinmrk(char *, int);
int getyes();
int inwind(int, int, int);
int menu(char *, char **);
int newmark();
int init_iod();
int sigcon(int, int, int, int);
int streak(int, int, float *);
int ulaw2linear(unsigned char);
void beep();
void blankmarks(int);
void calcquery();
void chaw(int);
void clrsts();
void clrmsg();
void cdcpfn(char *, char *);
void editquery();
void g_bar(int, int, int, int, int);
void g_box(int, int, int, int, int);
void g_drawmark(int, int, int);
void g_erase(int, int, int);
void g_init();
void g_rstscr(int, int, int);
void g_settextclr(int, int);
void g_text(int, int, char *);
void g_txt_cur(int, int);
void get_mouse_location(int *, int *);
void get_response(char *, char *, int);
void goto_samp(long);
void ins_new_mark();
void makescrn();
void modquery();
void ordmrk();
void putmsg(char *);
void putmsgwk(char *);
void putsts(char *);
void rootfn(char *, char *);
void saveseg(int, int, int);
void scan_signal(int);
void setup();
void showall();
void showdata();
void showhelp();
void showwindow(int);
void sigdel(int);
void sigmsg(int);
void update_mark(int, long);
void waitforkey();
void windinit(int);

#ifdef    WIN32
void    timer_wait(long, long);
void    timer_kill();
#endif /* WIN32 */
